<?php

use Zeedhi\Libraries\ClassGenerator\PHPBlock;
use Zeedhi\Libraries\ClassGenerator\PHPClass;
use Zeedhi\Libraries\ClassGenerator\PHPConstant;
use Zeedhi\Libraries\ClassGenerator\PHPMethod;
use Zeedhi\Libraries\ClassGenerator\PHPValue;
use Zeedhi\Libraries\ClassGenerator\PHPNamespace;
use Zeedhi\Libraries\ClassGenerator\PHPProperty;
use Zeedhi\Libraries\ClassGenerator\Type\Primary;

require "registerAll.php";

$acmeNamespace = new PHPNamespace("Acme");
$utilNamespace = new PHPNamespace("Util", $acmeNamespace);

//echo $utilNamespace->asPHP();

$toolClass = new PHPClass("Tool");
//$toolClass->setAbstract(true);
$toolClass->setNamespace($utilNamespace);
$toolClass->addConstant(new PHPConstant("MATERIAL_IRON","iron"));
$toolClass->addConstant(new PHPConstant("MATERIAL_STEEL","steel"));
$toolClass->addConstant(new PHPConstant("MATERIAL_WOOD","wood"));

$toolClass->addProperty(new PHPProperty("lastSerialNumber", new Primary(Primary::TYPE_INTEGER), PHPProperty::VISIBILITY_PUBLIC, new PHPValue(0), PHPProperty::IS_STATIC));
$toolClass->addProperty(new PHPProperty("serialNumber", new Primary(Primary::TYPE_INTEGER), PHPProperty::VISIBILITY_PRIVATE));
$toolClass->addProperty(new PHPProperty("material", new Primary(Primary::TYPE_STRING), PHPProperty::VISIBILITY_PROTECTED));

$constructorCode = new PHPBlock("\$this->material = \$material");
$constructorParameters = array(
    new \Zeedhi\Libraries\ClassGenerator\PHPParameter("material"),
);
$toolClass->addMethod(new PHPMethod("__construct", $constructorCode, $constructorParameters, PHPMethod::VISIBILITY_PUBLIC));

echo $toolClass->asPHP(), "\n";
echo "---------------------------------------------------\n";
$anvilClass = new PHPClass("Anvil", $toolClass);
$anvilClass->addMethod(new PHPMethod("__construct", new PHPBlock("parent::__construct(\\Acme\\Util\\Tool::MATERIAL_IRON);")));
$anvilClass->setNamespace($utilNamespace);
echo $anvilClass->asPHP(), "\n";